<p>U nastavku ćemo pogledati i kako pri stvaranju primjerka komponente obaviti povezivanje putem imena.
   Ova vrsta povezivanja je preferirani način povezivanja, i osim u trivijalnim slučajevima treba ga koristiti.</p>

<p>Prisjetimo se strukture naredbe kojom se u arhitekturu sklopa dodaje primjerak neke komponente.<br>
<em>nazivPrimjerkaKomponente</em> <code>:</code><br> 
&nbsp;&nbsp;&nbsp;&nbsp;<code>ENTITY</code> <em>nazivBiblioteke.imeSklopa</em><br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>PORT</code> <code>MAP</code> <code>(</code> <em>specifikacija povezivanja portova komponente</em> 
<code>)</code> <code>;</code>
</p>

<p>Pri <em>povezivanju putem imena</em>, unutar oblih zagrada koje dolaze nakon ključnih riječi <code>PORT</code>
   <code>MAP</code> navode se parovi ime porta pa signal koji se na njega spaja. Ime porta je od signala razdvojen
   simbolom <code>=&gt;</code>, a parovi su međusobno razdvojeni zarezima, baš kao što je bio slučaj i kod pozicijskog
   povezivanja.
</p>

<p>Pogledajmo to na našem radnom primjeru. Shema sklopa <em>sklop3</em> ponovno je prikazana na slici 1.</p>

<figure class="mlFigure">
<img src="@#file#(sklop3c.svg)" alt="Shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Konačna dopunjena shema sklopa <em>sklop3</em>.</figcaption>
</figure>

<p>Najprije ćemo napisati naredbu kojom ćemo u arhitekturi sklopa <em>sklop3</em> definirati da imamo komponentu
   <em>c1</em> koja je primjerak sklopa <em>sklop1</em>. Podsjetimo se kako je izgledalo sučelje sklopa 
   <em>sklop1</em>.</p>
<pre><code>ENTITY sklop1 IS PORT (
  a: IN std_logic;
  b: IN std_logic;
  c: IN std_logic;
  f: OUT std_logic
);
END sklop1;</code></pre>

<p>Naredba kojom ćemo u arhitekturi sklopa <em>sklop3</em> definirati da imamo komponentu
   <em>c1</em> koja je primjerak sklopa <em>sklop1</em> je oblika:</p>
<pre><code>c1: ENTITY work.sklop1 PORT MAP ( ... );</code></pre>
<p>Na mjestu gdje smo stavili tri točkice sada trebamo napisati povezivanje putem imena. Idemo redom.
   Stvaramo primjerak sklopa <em>sklop1</em>.</p>
<ol>
<li>Pogledajte u sučelje sklopa <em>sklop1</em> i odaberite bilo koji port. Primjerice neka smo odabrali
    port <code>b</code>. 
    Pogledajte shemu na slici 1: na njega se od sklopa <em>sklop3</em> dovodi
    ulaz <code>x</code>. Stoga u zagrade pišemo podatke za ovaj par - port <code>b</code> spojen je na
    ulaz <code>x</code>:<br>
    <code>(b =&gt; x ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop1</em> i odaberite neki drugi port; primjerice <code>f</code>.
    Pogledajte shemu na slici 1: od sklopa <em>sklop3</em>, na njega se dovodi interni signal <code>s</code>.
    Stoga u zagrade razdvojeno znakom zarez pišemo podatke za ovaj par - port <code>f</code> spojen je na
    interni signal <code>s</code>:<br>
    <code>(b =&gt; x, f =&gt; s ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop1</em> i odaberite neki treći port; primjerice <code>a</code>.
    Pogledajte shemu na slici 1: od sklopa <em>sklop3</em>, na njega se dovodi ulaz <code>a</code>.
    Stoga u zagrade razdvojeno znakom zarez pišemo podatke za ovaj par - port <code>a</code> spojen je na
    ulaz <code>a</code>:<br>
    <code>(b =&gt; x, f =&gt; s, a =&gt; a ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop1</em> i odaberite neki četvrti port; primjerice <code>c</code>.
    Pogledajte shemu na slici 1: od sklopa <em>sklop3</em>, na njega se dovodi ulaz <code>y</code>.
    Stoga u zagrade razdvojeno znakom zarez pišemo podatke za ovaj par - port <code>c</code> spojen je na
    ulaz <code>y</code>:<br>
    <code>(b =&gt; x, f =&gt; s, a =&gt; a, c =&gt; y)</code><br>
    čime je popis signala kompletan jer smo prošli kroz sve portove definirane u sučelju sklopa 
    <em>sklop1</em> i više nemamo što birati.</li>
</ol>
<p>Čitava naredba tada glasi:</p>
<pre><code>c1: ENTITY work.sklop1 PORT MAP (b =&gt; x, f =&gt; s, a =&gt; a, c =&gt; y);</code></pre>
<p>Naziv <em>povezivanje putem imena</em> proizlazi iz činjenice da kod ovog načina "spajanja" komponente
   eksplicitno kažemo koji je port povezivane komponente spojen na koji signal modelirane komponente.
   S obzirom na to da portove navodimo po imenima, popis parova možemo dati bilo kojim redoslijedom.</p>

<p>Ostalo nam je napisati naredbu kojom ćemo u arhitekturi sklopa <em>sklop3</em> definirati da imamo komponentu
   <em>c2</em> koja je primjerak sklopa <em>sklop2</em>. Ta će naredba biti oblika:</p>
<pre><code>c2: ENTITY work.sklop2 PORT MAP ( ... );</code></pre>
<p>Prisjetimo se kako je izgledalo sučelje sklopa <em>sklop2</em>.</p>
<pre><code>ENTITY sklop2 IS PORT (
  a: IN std_logic;
  b: IN std_logic;
  f: OUT std_logic
);
END sklop2;</code></pre>

<p>Idemo odrediti što ćemo pisati u oblim zagradama.</p>
<ol>
<li>Pogledajte u sučelje sklopa <em>sklop2</em> i odaberite bilo koji port. Primjerice, neka je to port <code>a</code>.
    Pogledajte shemu na slici 1: na njega je spojen interni signal <code>s</code> od sklopa <em>sklop3</em>.
    Stoga u zagrade pišemo podatke za taj par:<br>
    <code>(a =&gt; s ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop2</em> i odaberite neki drugi port. Primjerice, neka je to port <code>b</code>.
    Pogledajte shemu na slici 1: na njega je spojen ulaz <code>a</code> od sklopa <em>sklop3</em>.
    Stoga u zagrade nakon znaka zarez dopisujemo podatke za taj par:<br>
    <code>(a =&gt; s, b =&gt; a ...)</code></li>
<li>Pogledajte u sučelje sklopa <em>sklop2</em> i odaberite neki treći port. Primjerice, neka je to port <code>f</code>.
    Pogledajte shemu na slici 1: na njega je spojen izlaz <code>g</code> od sklopa <em>sklop3</em>.
    Stoga u zagrade nakon znaka zarez dopisujemo podatke za taj par:<br>
    <code>(a =&gt; s, b =&gt; a, f =&gt; g)</code><br>
    čime je popis signala kompletan jer smo prošli kroz sve portove definirane u sučelju sklopa 
    <em>sklop2</em>.</li>
</ol>
<p>Čitava naredba tada glasi:</p>
<pre><code>c2: ENTITY work.sklop2 PORT MAP (a =&gt; s, b =&gt; a, f =&gt; g);</code></pre>

<p>Čitav strukturni model sklopa <em>sklop3</em> napisan uporabom povezivanja putem imena prikazan je u nastavku.</p>

<pre><code>library ieee;
use ieee.std_logic_1164.all;

ENTITY sklop3 IS PORT (
  a: IN std_logic;
  x: IN std_logic;
  y: IN std_logic;
  f: OUT std_logic;
  g: OUT std_logic
);
END sklop3;

ARCHITECTURE str OF sklop3 IS
  SIGNAL s: std_logic;
BEGIN

  c1: ENTITY work.sklop1 PORT MAP (b =&gt; x, f =&gt; s, a =&gt; a, c =&gt; y);
  c2: ENTITY work.sklop2 PORT MAP (a =&gt; s, b =&gt; a, f =&gt; g);

  f &lt;= s;

END str;</code></pre>

<p>Redoslijed naredbi koje smo napisali u tijelu arhitekture nema nikakvog utjecaja na korektnost napisanog
   opisa. Podsjetimo: sve se naredbe u tijelu arhitekture izvode istovremeno.</p>

<p>Ovime smo završili pregled povezivanja putem imena komponenata kod izrade strukturnog modela.</p>

<div class="mlNote">
<p>Osim u trivijalnim slučajevima, uvijek koristite povezivanje putem imena. Time osiguravate puno veću
   robusnost za promjene u sučeljima komponenata. Primjerice, ako iz određenog razloga u sučelju neke
   komponente treba zamijeniti poredak signala, strukturne modele koji koriste tu komponentu kroz
   povezivanje putem imena neće trebati mijenjati!</p>
<p>Također, ako se u sučelje neke komponente pri nadogradnji odluči dodati neki port, kod stvaranja
   primjeraka te komponente koji koriste povezivanje putem imena dovoljno će biti na kraj dodati novu
   informaciju: na što je povezan taj dodani port. Koristi li se pozicijsko povezivanje, ovo može biti
   noćna mora: zamislite samo jednu komponentu koja ima 48 portova, i sada na 27. poziciju trebate upisati
   koji se signal spaja na taj novi port jer ste ga u sučelje umetnuli na 27. poziciju. Tu je vrlo jednostavno
   napraviti pogrešku.</p>
</div>

